
    #pragma comment(lib,"msimg32.lib")

    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //

    #pragma comment(linker, "-merge:.rdata=.text")
    #pragma comment(linker, "-align:0x1000")

    #include <WINDOWS.H>
    #include <WINDOWSX.H>
    #include "RESOURCE.H"
    
    #define  DLG_PARAMETERS \
             (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
            
    #define HANDLE_DLGMSG(dlg,msg,fn) \
            case (msg): return (SetDlgMsgResult(dlg,msg,\
                     HANDLE_##msg((dlg),(wParam),(lParam),(fn))))
                     
    #define HANDLE_WM_CLOSE(hwnd, wParam, lParam, fn) \
               ((fn)(hwnd, (DWORD) lParam), 0L)
               
    #undef  FORWARD_WM_CLOSE
               
    #define FORWARD_WM_CLOSE(hwnd, dwCloseCode, fn) \
               (VOID)(fn)((hwnd), WM_CLOSE, 0L, dwCloseCode)
               
    #define SIMPLE_TEST      0
    #define DIFFICULT_TEST   1
    
    #define  MAX_COMPLEXITY_TYPE    2
    #define  MAX_QUESTIONS         10
    #define  MAX_VARIANTS           4
    
    // ---- // ---- // ---- // ---- // ---- // ---- //
    
    #define ITEM_TEXT      1
    #define ITEM_PICTURE   2
      
    typedef struct ANSWER_ITEMS_tag
    {
      WORD fType, id;
      
      union { LPSTR szText; HBITMAP hBmp; } Data;
    }
      ANSWER_ITEMS, * PANSWER_ITEMS;
      
    PANSWER_ITEMS CurrentAnswers[MAX_VARIANTS];
    POINT   AnswersPaintPosition[MAX_VARIANTS];
    
    // ---- // ---- // ---- // ---- // ---- // ---- //
                     
    BOOL WINAPI DifficultyDlgProc DLG_PARAMETERS;
    BOOL WINAPI TestDlgProc DLG_PARAMETERS;
    BOOL WINAPI ResultTestDlgProc DLG_PARAMETERS;
    
    BOOL OnInitDifficultyDlg     (HWND, HWND, LPARAM);
    VOID OnCommandDifficultyDlg  (HWND, INT, HWND, UINT);
    VOID OnCloseDifficultyDlg    (HWND, DWORD); 
    
    BOOL OnInitTestDlg     (HWND, HWND, LPARAM);
    VOID OnCommandTestDlg  (HWND, INT, HWND, UINT);
    VOID OnPaintTestDlg    (HWND);
    VOID OnCloseTestDlg    (HWND, DWORD);
    
    BOOL OnInitResultTestDlg     (HWND, HWND, LPARAM);
    VOID OnCommandResultTestDlg  (HWND, INT, HWND, UINT);
    VOID OnCloseResultTestDlg    (HWND, DWORD);

    
    // ---- // ---- // ---- // ---- // ---- //
    
    VOID ForbidWindowClosing (HWND);
    
    VOID TestPaint (HDC hDC);
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    #pragma data_seg(".shared")
    
    static HINSTANCE g_hInstance = NULL;
    
    #pragma data_seg()
    #pragma comment(linker, "/section:.shared,rws")
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    WORD g_wDifficultyLevel = 0, g_CurrentQuest = 0;
    
    #include "init_quest.cpp"
    
    CHAR szTestDlgTitle[] = "   \"  \".";
    
    DWORD  dwUserAnswers[MAX_COMPLEXITY_TYPE][MAX_QUESTIONS] = {0};
    
    DWORD  dwCorrectAnswers[MAX_COMPLEXITY_TYPE][MAX_QUESTIONS] = \
    {
      {4, 2, 3, 3, 2, 4, 1, 4, 2, 4},
      {2, 1, 1, 2, 4, 3, 2, 1, 1, 3}
    };
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    INT WINAPI WinMain (HINSTANCE hInstance, HINSTANCE, LPSTR, INT)
    {
      if (g_hInstance != NULL)
      {
        HWND hTestDlg = FindWindow ("#32770", szTestDlgTitle);
        
        if (IsWindow (hTestDlg))
        {
          ShowWindow (hTestDlg, SW_RESTORE);
          SetForegroundWindow (hTestDlg);
        }
        
        return NO_ERROR;
      }
        else g_hInstance = hInstance;
        
      g_wDifficultyLevel = DialogBox (g_hInstance,
                     MAKEINTRESOURCE(IDD_DIFFICULTY_DLG), \
                                      HWND_DESKTOP, DifficultyDlgProc);
                                      
      if ((g_wDifficultyLevel != SIMPLE_TEST) &&
           (g_wDifficultyLevel != DIFFICULT_TEST)) return NO_ERROR;
                                      
      BOOL fTestCanceled = FALSE;
         
      for (WORD i=0; (i<MAX_QUESTIONS) && !fTestCanceled; i++)
      {
        dwUserAnswers[g_wDifficultyLevel][i] = \
            DialogBoxParam (g_hInstance, MAKEINTRESOURCE \
               (IDD_TEST_DLG + g_wDifficultyLevel*100+i), \
                   HWND_DESKTOP, TestDlgProc, g_CurrentQuest = i+1);
                                       
        fTestCanceled = (dwUserAnswers[g_wDifficultyLevel][i] == 0);
      }
      
      if ((i == MAX_QUESTIONS) && !fTestCanceled)
      {
        DialogBox (g_hInstance, \
           MAKEINTRESOURCE(IDD_RESULT_MSG_DLG), NULL, ResultTestDlgProc);
      }

      return NO_ERROR;
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    BOOL WINAPI DifficultyDlgProc DLG_PARAMETERS
    {
      switch (uMsg)
      {
        HANDLE_DLGMSG(hDlg, WM_INITDIALOG,  OnInitDifficultyDlg);
        HANDLE_DLGMSG(hDlg, WM_COMMAND,     OnCommandDifficultyDlg);
        HANDLE_DLGMSG(hDlg, WM_CLOSE,       OnCloseDifficultyDlg);
      }
      
      return FALSE;
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    BOOL WINAPI TestDlgProc DLG_PARAMETERS
    {
      switch (uMsg)
      {
        HANDLE_DLGMSG(hDlg, WM_INITDIALOG,   OnInitTestDlg);
        HANDLE_DLGMSG(hDlg, WM_COMMAND,      OnCommandTestDlg);
        HANDLE_DLGMSG(hDlg, WM_PAINT,        OnPaintTestDlg);
        HANDLE_DLGMSG(hDlg, WM_CLOSE,        OnCloseTestDlg);
      }
      
      return FALSE;
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    BOOL WINAPI ResultTestDlgProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
    {
      switch (uMsg)
      {
        HANDLE_MSG (hDlg, WM_INITDIALOG,  OnInitResultTestDlg);
        HANDLE_MSG (hDlg, WM_COMMAND,     OnCommandResultTestDlg);
        HANDLE_MSG (hDlg, WM_CLOSE,       OnCloseResultTestDlg);
      }
      
      return FALSE;
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    BOOL OnInitDifficultyDlg (HWND hDlg, HWND, LPARAM)
    {
      HICON hTitleIcon  = LoadIcon (g_hInstance, \
                                  MAKEINTRESOURCE(IDI_MAIN_ICON));
                                    
      HICON hButtonIcon = LoadIcon (g_hInstance, \
                                  MAKEINTRESOURCE(IDI_TEST_ICON));
                                    
      SendMessage (hDlg, WM_SETICON, TRUE,  (LPARAM) hButtonIcon);
      SendMessage (hDlg, WM_SETICON, FALSE, (LPARAM) hTitleIcon);
      
      SetWindowText (hDlg, szTestDlgTitle);
      ForbidWindowClosing (hDlg);
      
      Button_SetCheck (GetDlgItem(hDlg,IDC_SIMPLE_TEST), TRUE);
      
      return FALSE;
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID OnCommandDifficultyDlg \
                    (HWND hDlg, INT id, HWND hWndCtl, UINT uNotify)
    {
      DWORD dwResult = 0xFFFFFFFF;
      
      switch (id)
      {
        case IDC_BUTTON_CANCEL :
        
         FORWARD_WM_CLOSE (hDlg, dwResult, SendMessage);
         break;
             
        case IDC_BUTTON_OK :
         
         if (Button_GetCheck (GetDlgItem(hDlg,IDC_SIMPLE_TEST)))
            dwResult = SIMPLE_TEST;
         else
         if (Button_GetCheck (GetDlgItem(hDlg,IDC_DIFFICULT_TEST)))
            dwResult = DIFFICULT_TEST;
            
         if (dwResult != 0xFFFFFFFF) \
                   FORWARD_WM_CLOSE (hDlg, dwResult, SendMessage);
         break;
      }
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID OnCloseDifficultyDlg (HWND hDlg, DWORD dwReturn)
    {
      EndDialog (hDlg, dwReturn);
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    BOOL OnInitTestDlg (HWND hDlg, HWND, LPARAM nQuestion)
    {
      HICON hTitleIcon  = LoadIcon (g_hInstance, \
                                  MAKEINTRESOURCE(IDI_MAIN_ICON));
                                    
      HICON hButtonIcon = LoadIcon (g_hInstance, \
                                  MAKEINTRESOURCE(IDI_TEST_ICON));
                                    
      SendMessage (hDlg, WM_SETICON, TRUE,  (LPARAM) hButtonIcon);
      SendMessage (hDlg, WM_SETICON, FALSE, (LPARAM) hTitleIcon);
      
      SetWindowText (hDlg, szTestDlgTitle);
      ForbidWindowClosing (hDlg);
      
      GenerateQuestion ();
      InitQuestion (g_wDifficultyLevel, nQuestion);
      
      Button_SetCheck (GetDlgItem(hDlg, IDC_VARIANT_1), TRUE);
      
      for (WORD i=0; i<MAX_VARIANTS; i++)
        if (CurrentAnswers[i]->fType == ITEM_TEXT)
        {
          SetDlgItemText (hDlg, IDC_ITEM_1+i,\
                           CurrentAnswers[i]->Data.szText);
          
        }
          else
        {
          SetDlgItemText (hDlg, IDC_ITEM_1+i, NULL);
        }
      
      return FALSE;
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID OnPaintTestDlg (HWND hDlg)
    {
      PAINTSTRUCT ps; HDC hDC = BeginPaint (hDlg, &ps);
      
      TestPaint (hDC);
      
      EndPaint (hDlg, &ps);
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID OnCommandTestDlg \
                    (HWND hDlg, INT id, HWND hWndCtl, UINT uNotify)
    {
      DWORD dwResult = 0xFFFFFFFF;
      
      switch (id)
      {
        case IDC_CANCEL :
        
         FORWARD_WM_CLOSE (hDlg, 0, SendMessage);
         break;
             
        case IDC_NEXT :
        {
         
          BOOL fSelected = FALSE;
         
          for (BYTE i=0; (i<MAX_VARIANTS) && !fSelected; i++)
               fSelected = Button_GetCheck \
                         (GetDlgItem(hDlg,IDC_VARIANT_1+i));
                    
          if (fSelected) \
                 FORWARD_WM_CLOSE (hDlg, \
                        CurrentAnswers[i-1]->id, SendMessage);
               
          break;
        }
      }
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID OnCloseTestDlg (HWND hDlg, DWORD dwReturn=0)
    {
      EndDialog (hDlg, dwReturn);
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    BOOL OnInitResultTestDlg (HWND hDlg, HWND, LPARAM nQuestion)
    {
      HICON hTitleIcon  = LoadIcon (g_hInstance, \
                                  MAKEINTRESOURCE(IDI_MAIN_ICON));
                                    
      HICON hButtonIcon = LoadIcon (g_hInstance, \
                                  MAKEINTRESOURCE(IDI_TEST_ICON));
                                    
      SendMessage (hDlg, WM_SETICON, TRUE,  (LPARAM) hButtonIcon);
      SendMessage (hDlg, WM_SETICON, FALSE, (LPARAM) hTitleIcon);
      
      ForbidWindowClosing (hDlg);
      
      SetWindowText (hDlg, "    ...");
      
      WORD wRightAnswers = 0;
      
      for (WORD i=0; i<MAX_QUESTIONS; i++)
      {
        SetWindowText (GetDlgItem(hDlg,ID_RESULT_1+i),
           (dwUserAnswers[g_wDifficultyLevel][i]==\
              dwCorrectAnswers[g_wDifficultyLevel][i])?\
                  (wRightAnswers++,"!"):(" !"));
      }
      
      if ((wRightAnswers<=MAX_QUESTIONS) && (wRightAnswers>=MAX_QUESTIONS-1))
      {
        SetWindowText (GetDlgItem(hDlg,ID_RESULT_MARK), " : \"\"!");
      }
        else if ((wRightAnswers<=MAX_QUESTIONS-2) && (wRightAnswers>=MAX_QUESTIONS-3))
      {
        SetWindowText (GetDlgItem(hDlg,ID_RESULT_MARK), " : \"\"!");
      }
        else if ((wRightAnswers<=MAX_QUESTIONS-4) && (wRightAnswers>=MAX_QUESTIONS-5))
      {
        SetWindowText (GetDlgItem(hDlg,ID_RESULT_MARK), " : \"\"!");
      }
        else
      {
        SetWindowText (GetDlgItem(hDlg,ID_RESULT_MARK), " : \"\"!");
      }
      
      return TRUE;
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID OnCommandResultTestDlg (HWND hDlg, INT id, HWND hWndCtl, UINT uNotify)
    {
      switch (id)
      {
        case IDC_BUTTON_RESULT_OK :   EndDialog (hDlg, NO_ERROR);
      }
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID OnCloseResultTestDlg (HWND hDlg, DWORD dwCloseCode)
    {
      EndDialog (hDlg, dwCloseCode);
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID ForbidWindowClosing (HWND hDlg)
    {
      HMENU hMenu = GetSystemMenu (hDlg, FALSE);
          
      MENUITEMINFO mii;
      mii.cbSize = sizeof(MENUITEMINFO);
      mii.fMask = MIIM_STATE;
          
      GetMenuItemInfo (hMenu, SC_CLOSE, FALSE, &mii);
          
      mii.fMask = MIIM_STATE;
      mii.fState |= MFS_DISABLED;
      SetMenuItemInfo (hMenu, SC_CLOSE, FALSE, &mii);
          
      DWORD dwDlgClassStyle = GetClassLong (hDlg, GCL_STYLE);

      SetClassLong (hDlg, GCL_STYLE, dwDlgClassStyle | CS_NOCLOSE);
    }
    
    // ---- // ---- // ---- // ---- // ---- // ---- // ---- // ---- //
    
    VOID TestPaint (HDC hDC)
    {
      HDC hMemoryDC = CreateCompatibleDC (hDC);
      HBITMAP hOldBitmap = NULL;
      
      WORD cx = 0, cy = 0;
      
      if ((g_wDifficultyLevel == DIFFICULT_TEST)
                                 && g_CurrentQuest == 4) \
          cx = 79, cy = 25;
          
      if ((g_wDifficultyLevel == DIFFICULT_TEST)
                                 && g_CurrentQuest == 7) \
          cx = 84, cy = 45;
          
      if ((g_wDifficultyLevel == DIFFICULT_TEST)
                                 && g_CurrentQuest == 10) \
          cx = 28, cy = 40;
      
      for (WORD i=0; i<MAX_VARIANTS; i++)
        if (CurrentAnswers[i]->fType == ITEM_PICTURE)
        {
          hOldBitmap = (HBITMAP) SelectObject (hMemoryDC, \
                                    CurrentAnswers[i]->Data.hBmp);
                                    
          TransparentBlt (hDC, AnswersPaintPosition[i].x,\
               AnswersPaintPosition[i].y, cx, cy, \
                 hMemoryDC, 0, 0, cx, cy, RGB(0xFF,0xFF,0xFF));
             
          SelectObject (hMemoryDC, hOldBitmap);
        }
          else
        {
        }
        
      if ((g_wDifficultyLevel == DIFFICULT_TEST)
                                   && g_CurrentQuest == 7) \
      {
        HBITMAP hBitmap = (HBITMAP) LoadImage (g_hInstance,
                      MAKEINTRESOURCE(IDB_BMP_ITEM_5), \
                          IMAGE_BITMAP, 0, 0, LR_LOADTRANSPARENT);
        
        hOldBitmap = (HBITMAP) SelectObject (hMemoryDC, hBitmap);
                                    
        TransparentBlt (hDC, 135, 42, 81, 28, \
                 hMemoryDC, 0, 0, 81, 28, RGB(0xFF,0xFF,0xFF));
             
        SelectObject (hMemoryDC, hOldBitmap);
      }

      DeleteDC (hMemoryDC);
    }